#include "TForm.h"
#include <qtimer.h>
#include <stdlib.h>
#include <STXmlEngine.h>
#include <STStringList.h>
#include <STDriveOps.h>
#include <qtoolbutton.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qslider.h>

TForm::TForm(QWidget *parent, const char *name)
: TFormGUI(parent, name)
{
	CenteredOnce = false;
	SuppressSliderUpdate = false;
	XmlConfig = new STXmlEngine("/usr/local/lvs/conf/lvs.xml");
	ReadAppSettings();
	FileList = new STStringList();
	STDriveOps DriveOps;
	//DriveOps.SetDebugLevel(5);
	slider1->setMaxValue(1000);
	slider1->setValue(1000);
	DriveOps.ReturnParts.IncludePath = true;
	DriveOps.RecurseFiles(FileList , 6, VideoFilesDir);
	printf("Here = %s\n", (const char *)VideoFilesDir);
	printf("files = %d\n",FileList->Count());
	connect(PlayButton,SIGNAL(clicked()), SLOT(OnPlay()));
	connect(StopButton,SIGNAL(clicked()), SLOT(OnStop()));
	connect(BackButton,SIGNAL(clicked()), SLOT(OnBack()));
	connect(ForwardButton,SIGNAL(clicked()), SLOT(OnForward()));
	connect(slider1, SIGNAL(valueChanged(int)), SLOT(OnMoveToPos(int)));
	LoadImage(FileList->Count());
	// Set the view timer
	Timer1 = new QTimer(this,"Timer1");	
	ViewingStatus = "play";
	FirstLabel->setText(FormatImageName((const char*)FileList->Item(0)));
	
	connect(Timer1,SIGNAL(timeout()),SLOT(OnTimer1TimeOut()));	
	Timer1->start(100,false);
}

TForm::~TForm()
{
	STString SaveValue;
	printf("TForm::~TForm()\n");
	XmlEntry *Entry;
	if(GeometryChanged == true)
	{
		printf("save geometry\n");
		// Form height
		SaveValue.Sprintf("%d",height());
		Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = height");
		XmlConfig->SetValue(Entry->ParentEntry, "value", SaveValue);
	
		// Form witdh
		SaveValue.Sprintf("%d",width());
		Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = width");
		XmlConfig->SetValue(Entry->ParentEntry, "value", SaveValue);
	
		// Form top
		SaveValue.Sprintf("%d",pos().y());
		Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = top");
		XmlConfig->SetValue(Entry->ParentEntry, "value", SaveValue);
	
		// Form left
		SaveValue.Sprintf("%d",pos().x());
		Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = left");
		XmlConfig->SetValue(Entry->ParentEntry, "value", SaveValue);
	}
	printf("delete XmlConfig;\n");
	delete XmlConfig;
}


void TForm::ReadAppSettings()
{
	XmlEntry *Entry;
	STString GetValue;

	// Video files path
	Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = Video Files Path");
   GetValue = XmlConfig->GetValueDefault(Entry->ParentEntry, "value", "/mnt/video");
	printf("GetValue = %s\n",(const char*)GetValue);
	VideoFilesDir = GetValue;

	int SetFormLeft, SetFormTop, SetFormWidth, SetFormHeight;
	// Form height
	GetValue.Sprintf("%d",height());
	Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = height");
   GetValue = XmlConfig->GetValueDefault(Entry->ParentEntry, "value", GetValue);
	SetFormHeight = GetValue.ToInt();
	if((SetFormHeight < 300)||(SetFormHeight > 1300))
	{
		GetValue.Sprintf("%d",height());
		SetFormHeight = height();
		XmlConfig->SetValue(Entry->ParentEntry, "value", GetValue);
	}

	// Form witdh
	GetValue.Sprintf("%d",width());
	Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = width");
   GetValue = XmlConfig->GetValueDefault(Entry->ParentEntry, "value", GetValue);
	SetFormWidth = GetValue.ToInt();
	if((SetFormWidth < 300)||(SetFormWidth > 1300))
	{
		GetValue.Sprintf("%d",width());
		SetFormWidth = width();
		XmlConfig->SetValue(Entry->ParentEntry, "value", GetValue);
	}

	// Form top
	SetFormTop = (qApp->desktop()->height() / 2) - (SetFormHeight / 2);
	GetValue.Sprintf("%d",SetFormTop);
	Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = top");
   GetValue = XmlConfig->GetValueDefault(Entry->ParentEntry, "value", GetValue);
	SetFormTop = GetValue.ToInt();
	if((SetFormTop < 0)||(SetFormTop > 1000))
	{
		SetFormTop = (qApp->desktop()->height() / 2) - (SetFormHeight / 2);
		GetValue.Sprintf("%d",SetFormTop);
		XmlConfig->SetValue(Entry->ParentEntry, "value", GetValue);
	}

	// Form left
	SetFormLeft = (qApp->desktop()->height() / 2) - (SetFormHeight / 2);
	GetValue.Sprintf("%d",SetFormLeft);
	Entry = XmlConfig->GetEntryAutoCreate(0, "appsettings property name = left");
   GetValue = XmlConfig->GetValueDefault(Entry->ParentEntry, "value", GetValue);
	SetFormLeft = GetValue.ToInt();
	if((SetFormLeft < 0)||(SetFormLeft > 1000))
	{
		SetFormLeft = (qApp->desktop()->height() / 2) - (SetFormWidth / 2);
		GetValue.Sprintf("%d",SetFormLeft);
		XmlConfig->SetValue(Entry->ParentEntry, "value", GetValue);
	}
   setGeometry(SetFormLeft, SetFormTop, SetFormWidth, SetFormHeight);     
 	GeometryChanged = false;	
}

void TForm::closeEvent(QCloseEvent *EventPointer)
{
   EventPointer->accept();
}

void TForm::showEvent(QShowEvent *EventPointer)
{
   // This function is called when the for is first showed.
   // This code will center the form on the screen, it is commanly used.
   int TopPosition, LeftPosition, FormWidth, FormHeight;
   if(CenteredOnce == false)
   {
		 CenteredOnce = true;
		 FormWidth = width();
		 FormHeight = height();
		 LeftPosition = (qApp->desktop()->width() / 2) - (FormWidth / 2);
		 TopPosition = (qApp->desktop()->height() / 2) - (FormHeight / 2);
		 setGeometry(LeftPosition,TopPosition,FormWidth,FormHeight);     
    }
}

void TForm::OnTimer1TimeOut()
{
   // Find next picture
	if(ViewingStatus == "play")
	{
		// Look for any new pictures
		// If found any then add them to the list
		LastLabel->setText(FormatImageName((const char*)FileList->Item(FileList->Count() - 1)));

		// Advance to the last one
		LoadImage(ImageIndex + 1);
	} 
	
	// load the image found at this index in the list CurrentImageIndex
	
	// Load the image
}

QString TForm::FormatImageName(const char* FullPathName)
{
	QString NewString;
	
	NewString = FullPathName;
	NewString.remove(0, VideoFilesDir.Len() + 1);
	NewString.remove(NewString.length() - 4, NewString.length());
	return(NewString);
}

void TForm::resizeEvent(QResizeEvent* EventPointer)
{
	GeometryChanged = true;
}

void TForm::moveEvent(QMoveEvent* EventPointer)
{
	GeometryChanged = true;
}
void TForm::OnPlay()
{
	printf("OnPlay()\n");
	ViewingStatus = "play";
}

void TForm::OnStop()
{
	printf("OnStop()\n");
	ViewingStatus = "stop";
}

void TForm::OnBack()
{
	printf("OnBack()\n");
	LoadImage(ImageIndex - 100);
}

void TForm::OnForward()
{
	printf("OnForward()\n");
	LoadImage(ImageIndex + 100);
}

void TForm::OnMoveToPos(int MoveToThisRange)
{
	if(SuppressSliderUpdate == false)
	{
		int TotalCount, NextPosition;
		TotalCount = FileList->Count();
		NextPosition = (int)((float)TotalCount / 1000 * (float)MoveToThisRange);
		printf("move to new position = %d\n",NextPosition);
		LoadImage(NextPosition);
	}
}

void TForm::LoadImage(int NextImageIndex)
{
	int TotalCount, NextPosition;
	
	TotalCount = FileList->Count();
	if(TotalCount > 0)
	{
		ImageIndex = NextImageIndex;
		if(ImageIndex < 0)
		{
			ImageIndex = 0;	
		}		
		
		if(ImageIndex >= TotalCount)
		{
			ImageIndex = TotalCount - 1;
		}
		//printf("Image file = %s\n",(const char*)FileList->Item(ImageIndex));
		//pixmapLabel1->setPixmap(QPixmap((const char*)FileList->Item(ImageIndex)));
		QPixmap TempMap((const char*)FileList->Item(ImageIndex));
		int PosX, PosY;
		PosX = 5; //pixmapLabel1->left();
		PosY = 5; //pixmapLabel1->top();
		bitBlt(ImageFrame, PosX, PosY, &TempMap);
		ViewingLabel->setText(FormatImageName((const char*)FileList->Item(ImageIndex)));
		SuppressSliderUpdate = true;
		NextPosition = (int)((float)ImageIndex * (float)(1000 / (float)TotalCount));
		printf("auto move %d * (1000 / %d) = %d\n",ImageIndex, TotalCount, NextPosition);	
		slider1->setValue(NextPosition);
		SuppressSliderUpdate = false;
	}
}
