#ifndef TForm_included
#define TForm_included

#include <qapplication.h>
#include "TFormGUI.h"
#include <STString.h>

class STXmlEngine;
class STStringList;

class TForm: public TFormGUI
{
	Q_OBJECT
	public:
		bool CenteredOnce;
		bool SuppressSliderUpdate;
		bool GeometryChanged;
		STXmlEngine *XmlConfig;
		STString ViewingStatus;
		int CurrentImageIndex;	
		int ImageIndex;
		STString VideoFilesDir;
      QTimer *Timer1;
		STStringList *FileList;
		void ReadAppSettings();
		QString FormatImageName(const char* FullPathName);
		void LoadImage(int NextImageIndex);
		TForm(QWidget *parent, const char *name);
		~TForm();

   protected:
      virtual void closeEvent(QCloseEvent *EventPointer);     
      virtual void showEvent(QShowEvent *EventPointer);     
	   virtual void resizeEvent(QResizeEvent *EventPointer);
		virtual void moveEvent(QMoveEvent* EventPointer);
      
   private slots:
		void OnPlay();
		void OnStop();
		void OnBack();
		void OnForward();
      void OnTimer1TimeOut();
		void OnMoveToPos(int);
};

#endif // TForm_included
